import plotly
import plotly.graph_objs as go
from conEventLog import ConEventLog
import sys


##INSTALL PLOTLY and enum to use Python2.7 only

def Date(unxtime):
	import datetime
	return (datetime.datetime.fromtimestamp(int(unxtime)).strftime('%Y/%m/%d:%H/%M/%S'))

def DateSplit(unxtime):
	import datetime
	D = (datetime.datetime.fromtimestamp(int(unxtime)).strftime('%Y/%m/%d:%H/%M/%S'))
	date_ = D.split(":")[0]
	y,m,d = date_.split("/")
	time_ = D.split(":")[1]
	H,M,S = time_.split("/")
	return [y,m,d,H,M,S]

def blank():
	##blank dataset
	blank_ = []
	for i in range(0,1440): 
		blank_.append(0);
	return blank_


def FixTheD(D):
	##just a repersentation thing be nice that all values between engine on and off are same as on. aka to show a journey took place in that period of time.
	##we needto check for the auto-start function as well.
	LastOn=0;
	index=0;
	for i in D:
		if (i > 0): 
			LastOn=index;
		elif ((i < 0) and (LastOn > 0)):
			for ii in range(LastOn, LastOn + ( index - LastOn) ):
				D[ii]=5;
		index=index+1;
	return D


def ProcessDat(filename, year_start, month_start, year_end, month_end):
	conLog = ConEventLog.from_file(filename)
	Data = conLog.Data

	##PHASE 1: Load all the data into memory and organise it for use.
	MemorySink=[]
	for RawData in Data:
		dt=DateSplit(RawData.UnixTime)

		if ((int(dt[0]) >= int(year_start)) and (int(dt[1]) >= int(month_start))):

			if (RawData.EventID == 512):
				MemorySink.append([RawData.UnixTime,1])  ##engine on
			elif (RawData.EventID == 768):
				MemorySink.append([RawData.UnixTime,0])  ##engine off

	##PHASE 2: Sort by date and time.
	MemorySink = sorted(MemorySink,key=lambda x: x[0]);

	##PHASE 3: Sort into year, month, day collections of multi-dementional data
	#BiggerMemorySink! \o/ *oh the horrible code, the code must flow!*
	BMS = {}
	for value in MemorySink:
		dt= DateSplit(value[0])
		if ( BMS.has_key( str( dt[0]) ) == False ): ##YEAR
			BMS[ str(dt[0]) ]={}
		if ( BMS[ str(dt[0]) ].has_key( str(dt[1]) ) == False ): ##MONTH
			BMS[ str(dt[0]) ][ str(dt[1]) ] = {}
		if ( BMS[ str(dt[0]) ][ str(dt[1]) ].has_key( str(dt[2]) ) == False ): ##DAY
			BMS[ str(dt[0]) ][ str(dt[1]) ][ str(dt[2]) ] = blank()
		if (value[1] == 0): v = -1;
		elif (value[1] == 1): v = 1;
		else: v = 0;
		index = (int(dt[3]) * 60) + int(dt[4])
		BMS[ str(dt[0]) ][ str(dt[1]) ][ str(dt[2]) ][ index ] = BMS[ str(dt[0]) ][ str(dt[1]) ][ str(dt[2]) ][ index ] + v;

	##PHASE 4:
	###Ugly ugly ugly z and y lists!
	le_Z = [];
	le_Y = [];
	for i in BMS:
		Y = BMS[i];
		for ii in sorted(Y):
			M = Y[ii]
			for iii in sorted(M):
				D = M[iii]
				le_Y.append(iii+"/"+ii+"/"+i)
				le_Z.append(FixTheD(D))
	return le_Z, le_Y



def MakeGFX(zData,yData):
	blank = []
	for i in range(0,1440):
		h = ((i / 60))
		m = (i - (h * 60))
		blank.append( str(h)+":"+str(m) );
	data = [
		go.Heatmap(
			z=zData,
			x=blank,
			y=yData
		)
	]
	plotly.offline.plot(data, filename='heatmap.html')


def main(argv):
	if (len(argv) < 3):
		print "usage: gfx.py filename year-start month-start"
	else:
		year_start = argv[2];
		month_start = argv[3];
		filename = argv[1];
		zData, yData = ProcessDat(filename, year_start, month_start, 0, 0)
		MakeGFX(zData, yData)

if __name__ == "__main__":
	main(sys.argv)
